#ifndef INCbasics
#define INCbasics

#ifndef TRUE
#define TRUE  1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define NEW(type) (type *)tcaMalloc((unsigned) sizeof(type))

#define STREQ(str1, str2) (!(strcmp((str1),(str2))))

#define TCA_ERROR1(message, arg1) \
  { Log1(message, (char *)arg1); tcaError((char *)NULL); }

#define TCA_ERROR2(message, arg1, arg2) \
  { Log2(message, (char *)arg1, (char *)arg2); tcaError((char *)NULL); }

#define TCA_ERROR3(message, arg1, arg2, arg3) \
  { Log3(message, (char *)arg1, (char *)arg2, (char *)arg3); \
    tcaError((char *)NULL); }

#define TCA_MOD_ERROR1(message, arg1) \
  { (void)fprintf(stderr, message, (char *)arg1); \
    tcaModError((char *)NULL); }

#define TCA_MOD_ERROR2(message, arg1, arg2) \
  { (void)fprintf(stderr, message, (char *)arg1, (char *)arg2); \
    tcaModError((char *)NULL); }

#define TCA_MOD_ERROR3(message, arg1, arg2, arg3) \
  { (void)fprintf(stderr, message, (char *)arg1, (char *)arg2, (char *)arg3); \
    tcaModError((char *)NULL); }

/* the new sunos 4.1 for sun3 leaves out tolower/toupper in ctypes.h 
   this is still needed for the 4.0.3 systems */

#ifndef toupper
#define toupper(c) ((c)-'a'+'A')
#endif
#ifndef tolower
#define tolower(c) ((c)-'A'+'a')
#endif

extern void tcaFree(); /* defined in tcaMem.c */
extern char *tcaMalloc(); /* defined in tcaMem.c */
extern void tcaStats(); /* defined in tcaMem.c */

extern void exit(); /* doesn't seem to be defined correctly -- lint complains */
#ifndef VXWORKS
extern void cfree(); /* is not in fact defined in malloc.h -- lint complains */
#endif /* VXWORKS */

#endif /* INCbasics */

