/******************************************************************************
*
* PROJECT: Carnegie Mellon Planetary Rover Project
*          Task Control Architecture 
* 
* (c) Copyright 1991 Christopher Fedor and Reid Simmons.  All rights reserved.
* 
* MODULE: exception handling
*
* FILE: exception.h
*
* ABSTRACT:
* 
* exception code include.
*
* REVISION HISTORY
*
* 31-Dec-91 Reid Simmons, School of Computer Science, CMU
* Added facility to add exception handlers to class of messages, 
*  rather than just a single task tree node.
*
* 21-May-91 Christopher Fedor, School of Computer Science, CMU
* Revised to verion tca 5.x
*
* 25-Nov-89 Long-Ji Lin, School of Computer Science, CMU
* created.
*
******************************************************************************/

typedef struct {
  TCA_REF_PTR ref;
  char *hndName;
} ADD_EXC_TYPE, *ADD_EXC_PTR;

typedef struct {
  char *msgName, *hndName;
} ADD_EXC_MSG_TYPE, *ADD_EXC_MSG_PTR;

extern void reExecMsg();
