/*****************************************************************************
*
* (c) Copyright 1992. National Aeronautics and Space Administration.
*     Ames Research Center, Moffett Field, CA 94035-1000 
*
* FILE:     ftime.c
*
* ABSTRACT: An implementation of the SysV "ftime()" call for SGI's. It
*	    uses gettimeofday() to read the system clock with a default 
*	    resolution of 10 milliseconds. Better resolution is possible 
*	    if "ftimer" is used by the super-user to enable the fast clock.
*	    Q: so if SGI's are SysV based, how come they don't have ftime()?
*
* REVISION HISTORY:
*
* 13-Dec-91 Terry Fong. Created.
*
******************************************************************************/

#include "sys/time.h"
#include "timeb.h"

int ftime (tp)
     struct timeb *tp;
{
  struct timeval tv;
  struct timezone tz;
  int retval;

  retval = gettimeofday (&tv, &tz);

  tp->time = (time_t) tv.tv_sec;
  tp->millitm = (unsigned short) (tv.tv_usec / 1000);
  tp->timezone = (short) tz.tz_minuteswest;
  tp->dstflag = (short) tz.tz_dsttime;

  return (retval);
}
