/******************************************************************************
*
* PROJECT: Carnegie Mellon Planetary Rover Project
*          Task Control Architecture 
* 
* (c) Copyright 1991 Christopher Fedor and Reid Simmons.  All rights reserved.
* 
* MODULE: idTable
*
* FILE: idtable.h
*
* ABSTRACT:
* 
* Generic dynamic array abstract data type.
*
* REVISION HISTORY
*
* 25-Aug-90 Christopher Fedor, School of Computer Science, CMU
* Revised to Software Standards.
*
* 20-Feb-89 Christopher Fedor, School of Computer Science, CMU
* created.
*
******************************************************************************/

typedef struct _TELEM {
  int ref;
  char *data;
  struct _TELEM *next;
} TELEM_TYPE, *TELEM_PTR;

typedef struct {
  char *name;
  int incSize;
  int freeTotal; 
  int currentSize;
  TELEM_PTR table, freeList;
} ID_TABLE_TYPE, *ID_TABLE_PTR;

#define idTableItem(id, idTable) ((idTable->table+id)->data)

extern int idTableInsert();
extern char *idTableRemove();
extern void idTablePrintInfo();
extern ID_TABLE_PTR idTableCreate();
