/******************************************************************************
*
* PROJECT: Carnegie Mellon Planetary Rover Project
*          Task Control Architecture 
* 
* (c) Copyright 1991 Christopher Fedor and Reid Simmons.  All rights reserved.
* 
* MODULE: lex
*
* FILE: lex.h
*
* ABSTRACT:
* Lexer include
*
* REVISION HISTORY
*
* 10-Feb-89 Christopher Fedor, School of Computer Science, CMU
* Created.
*
******************************************************************************/

typedef enum {LBRACE_TOK, RBRACE_TOK, COMMA_TOK, LT_TOK, GT_TOK,
		STAR_TOK, BANG_TOK, COLON_TOK, LBRACK_TOK, RBRACK_TOK,
		INT_TOK, STR_TOK, PRIMITIVE_TOK, EOS_TOK} TokType;

typedef struct _Tok{
  int Loc;
  TokType Type;
  union {
    char *str;
    int num;
    int (*FormatFunc)();
  } value;
  struct _Tok *next;
} TokenType, *TokenPtr;




      
  
