/**************************************************************************
* 
* PROJECT: Carnegie Mellon Planetary Rover Project
*
* MODULE: list
*
* FILE: list.h
*
* ABSTRACT: The list module provides basic list creation and manipulation
* routines and serves as the base abstract data type for the tca.
* The include file list.h provides the top level routines for other modules.
*
* EXPORTS:
*
* REVISION HISTORY:
*
* See list.c for history.
*
**************************************************************************/

typedef struct _LIST_ELEM {
  char *item;
  struct _LIST_ELEM *next, *previous;
} LIST_ELEM_TYPE, *LIST_ELEM_PTR;

typedef struct _LIST {
  int length;
  struct _LIST *freeList;
  LIST_ELEM_PTR first, last, next;
} LIST_TYPE, *LIST_PTR;

extern LIST_PTR listCreate();
extern void listFree();
extern void listInsertItem();
extern void listDeleteItem();
extern void listFreeAllItems();
extern void listTestDeleteItem();
extern void listInsertItemAfter();

extern int listEqual();
extern int listLength();
extern int listIterate();
extern int listMemberItem();

extern LIST_PTR listCopy();

extern LIST_PTR listMake1();
extern LIST_PTR listMake2();

extern char *listFirst();
extern char *listNext();

extern void listInsertItemLast();
extern void listInsertItemFirst();
extern void listTestDeleteItemAll();
extern char *listPopItem();
extern char *listMemReturnItem();
