/*****************************************************************************
* PROJECT: Carnegie Mellon Planetary Rover Project
*          Task Control Architecture
*
* (c) Copyright 1991 Christopher Fedor and Reid Simmons.  All rights reserved.
* 
* MODULE: monitors
*
* FILE: mon.h
*
* ABSTRACT:
*
* Monitors
*
* REVISION HISTORY:
*
* 19-Mar-91 Christopher Fedor, School of Computer Science, CMU
* Replaced fireEveryCounter with condSatifiedCounter to be more explicit.
*
*  6-Aug-90 Christopher Fedor, School of Computer Science, CMU
* created.
*
*****************************************************************************/

#include "monMod.h"

typedef struct {
  int *id;
  int fireTime;
  int maxFireCounter;
  int condSatisfiedCounter;
  DISPATCH_PTR dispatch;
  MON_REG_DATA_PTR monInfo;
  QUANTITY_PTR expirationTime;
  INTERVAL_MON_CLASS_PTR intMonOps;
  struct _DURABLE_ITEM *durableItem;
} INTERVAL_MONITOR_DATA_TYPE, *INTERVAL_MONITOR_DATA_PTR;

typedef struct _DURABLE_ITEM {
  int endTime;
  DISPATCH_PTR dispatch;
  INTERVAL_MONITOR_DATA_PTR intMon;
} DURABLE_ITEM_TYPE, *DURABLE_ITEM_PTR;

#define NO_KEY -1
#define ALREADY_FIRED -1
#define ALREADY_CANCELLED -2

extern void setIntervalMonitorStartTime();
