/*****************************************************************************
* PROJECT: Carnegie Mellon Planetary Rover Project
*          Task Control Architecture
*
* (c) Copyright 1991 Christopher Fedor and Reid Simmons.  All rights reserved.
* 
* MODULE: monitors
*
* FILE: monMod.h
*
* ABSTRACT:
*
* Monitors Module Side
*
* REVISION HISTORY:
*
*  3-Oct-90 Christopher Fedor, School of Computer Science, CMU
* created.
*
*****************************************************************************/

#ifndef INCmonmod
#define INCmonmod

typedef struct {
  TCA_MSG_CLASS_TYPE class;
  char *monitorName, *conditionName, *actionName, *setUpName;
} MON_REG_DATA_TYPE, *MON_REG_DATA_PTR;

typedef struct {
  TCA_TIME_POINT_TYPE start, expire;
  INTERVAL_MONITOR_OPTIONS_PTR options;
} INTERVAL_MON_CLASS_TYPE, *INTERVAL_MON_CLASS_PTR;

#endif INCmonmod
