/*
* (c) Copyright 1991 Christopher Fedor and Reid Simmons.  All rights reserved.
* 
    The abstractions defined are QUEUE, STACK, PRIORITY_QUEUE and MEMORY.
    Each abstraction `X' supports the functions CREATE_X, FREE_X, 
        CLEAR_X, and IS_X_EMPTY.
   
    QUEUE additionally supports ENQUEUE and DEQUEUE, and it supports
        HEAD_ENQUEUE for getting items in a LIFO manner.
   
    STACK additionally supports PUSH_STACK and POP_STACK.
   
    PRIORITY_QUEUE supports PRIORITY_ENQUEUE and PRIORITY_DEQUEUE.
   
    MEMORY supports REMEMBER and DO_MEMORY (which applys a function to each
       `remembered' item in a last in, first out manner).


    29-Jul-91 Reid Simmons   Rewrote entirely to use Chris' list package.
*/

/*                QUEUES                */

typedef struct { 
  struct _LIST *list;
} queue_type, *queue_ptr;

extern queue_ptr Create_Queue ();

/* extern void Free_Queue(); */

extern void Clear_Queue ( /* queue_ptr queue */ );

/* extern int Is_Queue_Empty(); */

extern void Enqueue ( /* char *data, queue_ptr queue */ );

extern char *Dequeue ( /* queue_ptr queue */ );

extern void Head_Enqueue ( /* char *data, queue_ptr queue */ );

/*                STACKS                */

typedef struct {
  struct _LIST *list;
} stack_type, *stack_ptr;

extern stack_ptr Create_Stack ();

/* extern void Free_Stack(); */

/* extern void Clear_Stack(); */

/* extern int Is_Stack_Empty(); */

extern void Push_Stack ( /* char *data; stack_ptr stack */ );

extern  char *Pop_Stack ( /* stack_ptr stack */ );

/*                PRIORITY_QUEUES                */

typedef struct { 
  struct _LIST *list;
  int (*valueLesspFn)();
} priority_queue_type, *priority_queue_ptr;

/* extern priority_queue_ptr Create_Priority_Queue(); */

/* extern void Free_Priority_Queue(); */

/* extern void Clear_Priority_Queue(); */

/* extern int Is_Priority_Queue_Empty(); */

/* extern void Priority_Enqueue(); */

/* extern char *Priority_Dequeue(); */

/*                MEMORIES                */

typedef struct { 
  struct _LIST *list;
} memory_type, *memory_ptr;

extern memory_ptr Create_Memory ();

/* extern void Free_Memory(); */

extern void Clear_Memory ( /* memory_ptr memory */ );

/* extern int Is_Memory_Empty(); */

extern void Remember ( /* char *data, memory_ptr memory */ );

extern void Do_Memory ( /* memory_ptr memory, void (* memory_fn)() */ );
