/******************************************************************************
*
* PROJECT: Carnegie Mellon Planetary Rover Project
*          Task Control Architecture 
* 
* (c) Copyright 1991 Christopher Fedor and Reid Simmons.  All rights reserved.
* 
* MODULE: resources
*
* FILE: res.h
*
* ABSTRACT:
* 
* Resources
*
* REVISION HISTORY
*
* 26-Aug-90 Christopher Fedor, School of Computer Science, CMU
* New implmentation of resources - tca version 5.0.
*
* 13-Mar-89 Christopher Fedor, School of Computer Science, CMU
* created.
*
******************************************************************************/

typedef enum {ActiveResource, ReservedResource, LockedResource} 
              RESOURCE_STATUS_TYPE;

typedef struct _RESOURCE {
  int sd;
  char *name;
  int capacity;
  MODULE_PTR module;
  RESOURCE_STATUS_TYPE status;
  struct _LIST *pendingList, *attendingList;
} RESOURCE_TYPE, *RESOURCE_PTR;

#define RESOURCE_SET_STATUS(stat, resource) (resource->status = stat) 

extern void resourceDelete();
extern void resourcePending();
extern void resourceAttending();
extern void resourceProcessPending();
extern void resourceProcessPendingRes();
extern void resourceRemoveAttending();
extern void resourceRemovePending();

extern void resourceInitialize();

extern int resourceAvailable();
extern int resourceAvailableRes();

extern RESOURCE_PTR resourceCreate();

