/*
  tcaModError.c
* (c) Copyright 1991 Christopher Fedor and Reid Simmons.  All rights reserved.
* 

   6-Nov-92: reids: Changed to write to stderr; Will *always* flush in LISP
                    (so can remove flushing each place tcaModError is called).
  25-Oct-90: fedor: created to avoid logging in modules.
*/

#ifdef VXWORKS
#include "stdioLib.h"
#else
#include "stdio.h"
#endif

#include "basics.h"

/* extern void (*errorHndGlobal)();*/
/* exit routine as well? 25-Oct-90: fedor */

#ifdef LISP
extern int (*lispExitGlobal)();
#endif

tcaModError(description)
char *description;
{
  tcaStats();

#ifndef VXWORKS
  if (description) {
    fprintf(stderr, "%s\n", description);
  }
#ifdef LISP
    fflush(stderr);
#endif

#ifdef LISP
  (*lispExitGlobal)();
#else
  exit(1);
#endif

#else
  fprintf(stderr, "%s\n", description);
  tcaVxAbort();
#endif
}  
