/*
  tms.h

*/

typedef struct { 
  char *informant;
  LIST_PTR supporters;
} JUSTIFICATION_TYPE, *JUSTIFICATION_PTR;

typedef struct _TMS_NODE_TYPE {
  char *datum;
  LIST_PTR consequents;
  LIST_PTR justifications;
  LIST_PTR rules;
  JUSTIFICATION_PTR supportJustification;
  /* should be "CELL_PTR" but I wanted to keep this modular */
  struct _CELL_TYPE *cell;
} TMS_NODE_TYPE, *TMS_NODE_PTR;

typedef struct { 
  TMS_NODE_PTR node;
  JUSTIFICATION_PTR justification;
} CONSEQUENT_TYPE, *CONSEQUENT_PTR;

#define IS_IN(tms_node) (!IS_OUT(tms_node))
#define IS_OUT(tms_node) ((tms_node)->supportJustification == NULL)
#define NODE_DATUM(tms_node) ((tms_node)->datum)
#define NODE_JUSTIFICATIONS(tms_node) ((tms_node)->justifications)

#define NODE_SUPPORT_JUSTIFICATION(tms_node) \
((tms_node)->supportJustification)

#define IS_ASSUMED(tms_node) \
  ((tms_node)->supportJustification == tmsAssumpJustificationGlobal)

extern void tmsInit();
extern TMS_NODE_PTR tmsCreateNode();
extern void tmsFreeNode();

extern JUSTIFICATION_PTR tmsCreateJustification();
extern JUSTIFICATION_PTR tmsCreateJustification1();

extern void tmsJustifyNode();

extern void tmsAssumeNode();
extern void tmsUnassumeNode();

extern void tmsAssertNode();
extern void tmsUnassertNode();

extern void tmsContradictory();

extern LIST_PTR tmsSupport();

extern int tmsIsPremise();

/* extern int tmsIsDerived(); */

extern TMS_NODE_PTR tmsContraNodeGlobal;
   
extern JUSTIFICATION_PTR tmsAssumpJustificationGlobal;

extern void tmsInNode();
extern void tmsOutNode();

extern int tmsTraceGlobal;


extern void tmsPrintTruth();
